"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mkdirp = require("mkdirp-promise");
const fs = require("mz/fs");
const path = require("path");
const pathTemp = require("path-temp");
const rimraf = require("rimraf-then");
async function linkIndexedDir(existingDir, newDir, filenames) {
    const stage = pathTemp(path.dirname(newDir));
    try {
        await rimraf(stage);
        await tryLinkIndexedDir(existingDir, stage, filenames);
        await rimraf(newDir);
        await fs.rename(stage, newDir);
    }
    catch (err) {
        try {
            await rimraf(stage);
        }
        catch (err) { } // tslint:disable-line:no-empty
        throw err;
    }
}
exports.default = linkIndexedDir;
async function tryLinkIndexedDir(existingDir, newDir, filenames) {
    const alldirs = new Set();
    filenames
        .forEach((f) => {
        alldirs.add(path.join(newDir, path.dirname(f)));
    });
    await Promise.all(Array.from(alldirs).sort((d1, d2) => d1.length - d2.length).map((dir) => mkdirp(dir)));
    await Promise.all(filenames
        .map((f) => fs.link(path.join(existingDir, f), path.join(newDir, f))));
}
//# sourceMappingURL=linkIndexedDir.js.map